#include "Bateau.h"
#include <math.h>
#include "Conduite.h"

#define EP_GOUV 0.1
extern TForm1 *Form1;
//---------------------------------------------------------------------------
Bateau::Bateau()
{        etat.x=0.0f;
         etat.y=1.0f;
         etat.theta = PI/6;
         etat.v = 3.0f;
         etat.omega = 0.0f;
         beta=0.05;J=3000.0;rg=4.0;
         alphatheta=2000.0;  m=1000.0;  alphaf=100.0;  rv=2.0;  alphag=250.0;
         l=2.0;alphav=500.0;
}
//---------------------------------------------------------------------------
void Bateau::Incremente(float dT,float deltav,float deltag)
{       fv    = alphav*V*cos(etat.theta+deltav)-alphav*etat.v*sin(deltav);
        fg    = alphag*etat.v*sin(deltag);
        etat.x          += etat.v*cos(etat.theta)*dT;
        etat.y          += (etat.v*sin(etat.theta)-beta*V)*dT;
        etat.theta      += etat.omega*dT;
        etat.omega      += (1/J)*((l-rv*cos(deltav))*fv
                          -rg*cos(deltag)*fg-alphatheta*etat.omega)*dT;
        etat.v          += (1/m)*(sin(deltav)*fv-sin(deltag)*fg-alphaf*etat.v)*dT;
}

//---------------------------------------------------------------------------
void Bateau::Draw()
{       glTranslatef(etat.x,etat.y,0);
        float c=(V+(random(2)-0.5))/3  ;  //flche vent
        glLineWidth(2);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);			// Enable Alpha Blending (disable alpha testing)
	glEnable(GL_BLEND);
        glBegin(GL_LINES);
                glColor3f(0,0.7,0);
                glVertex3f(3,-4,13);
                glVertex3f(3,-4-c,13);
                glVertex3f(3,-4-c,13);
                glVertex3f(3,-4-c,14);
                glVertex3f(3,-4-c,14);
                glVertex3f(3,-5.5-c,12.5);
                glVertex3f(3,-5.5-c,12.5);
                glVertex3f(3,-4-c,11);
                glVertex3f(3,-4-c,11);
                glVertex3f(3,-4-c,12);
                glVertex3f(3,-4-c,12);
                glVertex3f(3,-4,12);
                glVertex3f(3,-4,12);
                glVertex3f(3,-4,13);

        glEnd();

        glRotatef(etat.theta*RadToDeg,0,0,1);
        //coque:
        float h = 1.0f; //hauteur
        //glRotatef(180,0,0,1);

         glBegin(GL_POLYGON);    //partie cach du plancher
                glColor3f(0,0,0);

                //glVertex3f(3.56, -1.12, 0.01);
                glVertex3f(4.5,-0.75, 0.01);
                glVertex3f(5.06,-0.375, 0.01);
                glVertex3f(5.25,0, 0.01);
                glVertex3f(5.06,0.375, 0.01);
                glVertex3f(4.5,0.75, 0.01);
                //glVertex3f(3.56,1.12, 0.01);
          glEnd();
          glEnable(GL_TEXTURE_2D);
          glBindTexture(GL_TEXTURE_2D,6);
          glBegin(GL_QUADS);   //plancher
                glTexCoord2f(0,0); glVertex3f(-1,-1.5,0.01);
                glTexCoord2f(1,0); glVertex3f(3,-1.5, 0.01);

                glTexCoord2f(1,1); glVertex3f(3,1.5,0.01);  glTexCoord2f(0,1);  glVertex3f(-1,1.5,0.01);
          glEnd();

          /*glBegin(GL_POLYGON);
                glColor3f(0,0,0);
                glVertex3f(-1,-2,0.01);  glVertex3f(4,-2,0.01); //fond noir
                glVertex3f(5,-1,0.01);   glVertex3f(5,1,0.01);
                glVertex3f(4,2,0.01);    glVertex3f(-1,2,0.01);
          glEnd();*/
         glBindTexture(GL_TEXTURE_2D,7);
         glTranslatef(0.01,0,0.01);
         glBegin(GL_POLYGON);  //dessus avant
                glColor3f(1,0,0);
                glTexCoord2f(0,0); glVertex3f(3,-2,h); glTexCoord2f(0.033, 0.02); glVertex3f(3.1,-1.9,h+0.01); glTexCoord2f(0.25,0.1); glVertex3f(3.75,-1.6, h+0.01);
                glTexCoord2f(0.66,0.25); glVertex3f(5.0,-1,h+0.01); glTexCoord2f(0.91, 0.375); glVertex3f(5.75,-0.5,h+0.01); glTexCoord2f(1, 0.5); glVertex3f(6.0, 0, h+0.01); glTexCoord2f(0.91, 0.63); glVertex3f(5.75,0.5,h+0.01); glTexCoord2f(0.66, 0.75); glVertex3f(5.0,1,h+0.01);  glTexCoord2f(0.25, 0.9); glVertex3f(3.75,1.6,h+0.01);
                glTexCoord2f(0.033,0.98); glVertex3f(3.1,1.9,h+0.01);    glTexCoord2f(0,1); glVertex3f(3,2,h+0.01);
          glEnd();
          glTranslatef(-0.01,0,0);
          glDisable(GL_TEXTURE_2D);
         /*glBegin(GL_POLYGON);
                glColor3f(1,0,0);
                glVertex3f(-1,-2,h);  glVertex3f(4,-2,h); //dessus rouge
                glVertex3f(5,-1,h);   glVertex3f(5,1,h);
                glVertex3f(4,2,h);    glVertex3f(-1,2,h);
          glEnd();  */
          glEnable(GL_TEXTURE_2D);
          glBindTexture(GL_TEXTURE_2D, 3);
          glBegin(GL_POLYGON); //faces latrales
                glColor3f(0,1,0);
                //glNormal3f(0,-1,0);
                glTexCoord2f(0,0); glVertex3f(-1,-1.5,0); glTexCoord2f(0,0.5); glVertex3f(-1, -1.9, h/2); glTexCoord2f(0,1); glVertex3f(-1,-2,h);
                glTexCoord2f(1,1); glVertex3f(3,-2,h);  glTexCoord2f(1, 0.5); glVertex3f(3, -1.9, h/2);  glTexCoord2f(1,0); glVertex3f(3,-1.5,0);
                glTexCoord2f(0,0); glVertex3f(-1,-1.5,0);
           glEnd();

          glBegin(GL_POLYGON); //faces latrales
                glColor3f(0,1,0);
                //glNormal3f(0,-1,0);
                glTexCoord2f(0,0); glVertex3f(-1,1.5,0); glTexCoord2f(0,0.5); glVertex3f(-1, 1.9, h/2); glTexCoord2f(0,1); glVertex3f(-1,2,h);
                glTexCoord2f(1,1); glVertex3f(3,2,h);  glTexCoord2f(1, 0.5); glVertex3f(3, 1.9, h/2);  glTexCoord2f(1,0); glVertex3f(3,1.5,0);
                glTexCoord2f(0,0); glVertex3f(-1,1.5,0);
           glEnd();
            glBindTexture(GL_TEXTURE_2D, 4);
            glTranslatef(0,-0.01,0);
            glBegin(GL_QUADS);              //banc
                 glColor3f(1,1,1);

                glTexCoord2f(0, 1.4); glVertex3f(-1,2,h);
                glTexCoord2f(0,1); glVertex3f(-1, 1.3, h);
                glTexCoord2f(1.0, 1.0); glVertex3f(3, 1.3, h);
                glTexCoord2f(1.0, 1.4); glVertex3f(3,2,h);

                glTexCoord2f(0,1); glVertex3f(-1, 1.3, h);
                glTexCoord2f(0,2/3); glVertex3f(-1, 1.1, 4*h/5);
                glTexCoord2f(1.0, 2/3); glVertex3f(3, 1.1, 4*h/5);
                glTexCoord2f(1.0, 1.0); glVertex3f(3, 1.3, h);

                glTexCoord2f(0.0, 2/3); glVertex3f(-1, 1.1, 4*h/5);
                glTexCoord2f(0.0, 1); glVertex3f(-1, 0.9, 3*h/5);
                glTexCoord2f(1.0, 1); glVertex3f(3, 0.9, 3*h/5);
                glTexCoord2f(1.0, 2/3); glVertex3f(3, 1.1, 4*h/5);


                glTexCoord2f(0, 2/3); glVertex3f(-1, 0.9, 3*h/5);
                glTexCoord2f(0,1); glVertex3f(-1,0.8,0);
                glTexCoord2f(1.0,1.0); glVertex3f(3,0.8,0);
                glTexCoord2f(1.0, 2/3); glVertex3f(3, 0.9, 3*h/5);




                //glTexCoord2f(0, 1.4); glVertex3f(-1,2,h);
                //glVertex3f(4,1.5,0);
            glEnd();
            glTranslatef(0,0.01,0);

            glTranslatef(0,0.01,0);

            glBegin(GL_QUADS);              //banc
                 glColor3f(1,1,1);

                glTexCoord2f(0, 1.4); glVertex3f(-1,-2,h);
                glTexCoord2f(0,1); glVertex3f(-1, -1.3, h);
                glTexCoord2f(1.0, 1.0); glVertex3f(3, -1.3, h);
                glTexCoord2f(1.0, 1.4); glVertex3f(3,-2,h);

                glTexCoord2f(0,1); glVertex3f(-1, -1.3, h);
                glTexCoord2f(0,2/3); glVertex3f(-1, -1.1, 4*h/5);
                glTexCoord2f(1.0, 2/3); glVertex3f(3, -1.1, 4*h/5);
                glTexCoord2f(1.0, 1.0); glVertex3f(3, -1.3, h);

                glTexCoord2f(0.0, 2/3); glVertex3f(-1, -1.1, 4*h/5);
                glTexCoord2f(0.0, 1); glVertex3f(-1, -0.9, 3*h/5);
                glTexCoord2f(1.0, 1); glVertex3f(3, -0.9, 3*h/5);
                glTexCoord2f(1.0, 2/3); glVertex3f(3, -1.1, 4*h/5);


                glTexCoord2f(0, 2/3); glVertex3f(-1, -0.9, 3*h/5);
                glTexCoord2f(0,1); glVertex3f(-1,-0.8,0);
                glTexCoord2f(1.0,1.0); glVertex3f(3,-0.8,0);
                glTexCoord2f(1.0, 2/3); glVertex3f(3, -0.9, 3*h/5);




                //glTexCoord2f(0, 1.4); glVertex3f(-1,2,h);
                //glVertex3f(4,1.5,0);
            glEnd();
            /*glBegin(GL_POLYGON);              //banc
                 glColor3f(1,1,1);
                glTexCoord2f(0.0,0.0); glVertex3f(3,-0.8,0);  glTexCoord2f(0.0, 1/3); glVertex3f(3, -0.9, h/3);  glTexCoord2f(0.0, 2/3); glVertex3f(3, -1.2, 2*h/3); glTexCoord2f(0.0, 1.0); glVertex3f(3, -1.6, h); glTexCoord2f(0.0, 0.4); glVertex3f(3,-2,h);
                glTexCoord2f(1, 0.4); glVertex3f(-1,-2,h); glTexCoord2f(1,1); glVertex3f(-1, -1.6, h); glTexCoord2f(1,2/3); glVertex3f(-1, -1.2, 2*h/3); glTexCoord2f(1, 1/3); glVertex3f(-1, -0.9, h/3); glTexCoord2f(1,0); glVertex3f(-1,-0.8,0);

//                glVertex3f(3,-0.8,0);  glVertex3f(3, -0.9, h/3);  glVertex3f(3, -1.2, 2*h/3); glVertex3f(3, -1.6, h); glVertex3f(3,-2,h);
//                glVertex3f(-1,-2,h);  glVertex3f(-1, -1.6, h); glVertex3f(-1,-1.2, 2*h/3); glVertex3f(-1, -0.9, h/3); glVertex3f(-1,-0.8,0);
                //glVertex3f(4,-1.5,0);
            glEnd();  */            glTranslatef(0,-0.01,0);
            glDisable(GL_TEXTURE_2D);
          /*glBegin(GL_POLYGON); //faces latrales
                glColor3f(0,1,0);
                glNormal3f(0,-1,0);
                glVertex3f(-1,-2,0);  glVertex3f(-1,-2,h);
                glVertex3f(4,-2,h);     glVertex3f(4,-2,0);
                glVertex3f(-1,-2,0);
           glEnd();
          glBegin(GL_POLYGON);
                 glNormal3f(0,1,0);
                glVertex3f(4,2,0);      glVertex3f(4,2,h);
                glVertex3f(-1,2,h);     glVertex3f(-1,2,0);
                glVertex3f(4,2,0);
            glEnd();    */
          glEnable(GL_TEXTURE_2D);
          glBindTexture(GL_TEXTURE_2D, 7);
          glBegin(GL_POLYGON); //face "avant mat"
                glColor3f(0,0,1);
                glNormal3f(-1,0,0);
                glTexCoord2f(0.0,0.25);glVertex3f(3+0,-1.5+0.4,0); glTexCoord2f(0.05,0.5); glVertex3f(3+0, -1.9+0.4, h/2);  glTexCoord2f(0,1.0); glVertex3f(3+0,-2+0.4,h);
                glTexCoord2f(1,1.0); glVertex3f(3+0,2-0.4,h); glTexCoord2f(0.95,0.5);  glVertex3f(3+0, 1.9-0.4, h/2); glTexCoord2f(0.75,0.25); glVertex3f(3+0,1.5-0.4,0);
                glTexCoord2f(0.0,0.25); glVertex3f(3+0,-1.5+0.4,0);
            glEnd();

          glTranslatef(-0.01,0,0);
          glEnable(GL_TEXTURE_2D);
          glBindTexture(GL_TEXTURE_2D, 3);
          glBegin(GL_POLYGON); //face arrire
                glColor3f(0,1,0);
                glNormal3f(-1,0,0);
                glTexCoord2f(0.0,0.25);  glVertex3f(-1,-1.5,0); glTexCoord2f(0.05,0.5);
                glVertex3f(-1, -1.9, h/2);  glTexCoord2f(0,1.0);  glVertex3f(-1,-2,h);
                glTexCoord2f(1,1); glVertex3f(-1,2,h);
                glTexCoord2f(0.95,0.5);
                glVertex3f(-1, 1.9, h/2); glTexCoord2f(0.75,0.25);  glVertex3f(-1,1.5,0);
                glTexCoord2f(0.0,0.25); glVertex3f(-1,-1.5,0);
            glEnd();
            glDisable(GL_TEXTURE_2D) ;
            glTranslatef(0.01,-0.01,0);
          /*glBegin(GL_POLYGON);//face avant
                glNormal3f(1,0,0);
                glVertex3f(5,-1,0);     glVertex3f(5,-1,h);
                glVertex3f(5,1,h);      glVertex3f(5,1,0);
                glVertex3f(5,-1,0);
            glEnd();  */


          glTranslatef(0.00,-0.00,0);
          glEnable(GL_TEXTURE_2D);
          glBindTexture(GL_TEXTURE_2D, 3);
          glBegin(GL_POLYGON);
                //glColor3f(1,0,0);
                glTexCoord2f(0,1); glVertex3f(3,-2,h); glTexCoord2f(0.03, 1); glVertex3f(3.1,-1.7,h);
                glTexCoord2f(0.25, 1); glVertex3f(3.75,-1.5, h);//avant
                glTexCoord2f(0.66, 1); glVertex3f(5.0,-1,h); glTexCoord2f(0.91, 1); glVertex3f(5.75,-0.5,h);
                glTexCoord2f(1,1); glVertex3f(6.0, 0, h);
                glTexCoord2f(0.91, 3/4); glVertex3f(5.25,0, 0);
                //glTexCoord2f(0.83,3/8); glVertex3f(4.5,0, 3/8*h);
                //glTexCoord2f(0.75,0); glVertex3f(4.25,0, 0);
                //glVertex3f(5.0,0, 0);
                glTexCoord2f(0.66, 0); glVertex3f(5.06,-0.375, 0);
                glTexCoord2f(0.5, 0); glVertex3f(4.5,-0.75, 0);
                //glVertex3f(3.56,-1.12, 0);
                glTexCoord2f(0,0); glVertex3f(3,-1.5,0);  glTexCoord2f(0,0.5); glVertex3f(3, -1.9, h/2);   glTexCoord2f(0,1); glVertex3f(3,-2,h);
          glEnd();
          glTranslatef(0,0.00,0);


          glBegin(GL_POLYGON);
                //glColor3f(1,0,0);
                glTexCoord2f(0,1); glVertex3f(3,2,h); glTexCoord2f(0.03, 1); glVertex3f(3.1,1.7,h);
                glTexCoord2f(0.25, 1); glVertex3f(3.75,1.5, h);//avant
                glTexCoord2f(0.66, 1); glVertex3f(5.0,1,h); glTexCoord2f(0.91, 1); glVertex3f(5.75,0.5,h);
                glTexCoord2f(1,1); glVertex3f(6.0, 0, h);
                glTexCoord2f(0.91, 3/4); glVertex3f(5.25,0, 0);
                //glTexCoord2f(0.83,3/8); glVertex3f(4.5,0, 3/8*h);
                //glTexCoord2f(0.75,0); glVertex3f(4.25,0, 0);
                //glVertex3f(5.0,0, 0);
                glTexCoord2f(0.66, 0); glVertex3f(5.06,0.375, 0);
                glTexCoord2f(0.5, 0); glVertex3f(4.5,0.75, 0);
                //glVertex3f(3.56,-1.12, 0);
                glTexCoord2f(0,0); glVertex3f(3,1.5,0);  glTexCoord2f(0,0.5); glVertex3f(3, 1.9, h/2);   glTexCoord2f(0,1); glVertex3f(3,2,h);
          glEnd();
          glTranslatef(-0.00,-0.00,0);

          /*glBegin(GL_TRIANGLE_STRIP);
                //glColor3f(1,0,0);
                glVertex3f(6.0, 0, h); glVertex3f(5.75,0, 3/4*h); glVertex3f(5.75,-0.5,h);
                //glVertex3f(5.0,0, 3.0/4*h);
                glVertex3f(3.75,0, 1/4*h); glVertex3f(5.0,-1,h); glVertex3f(3,0, 0);  glVertex3f(3.75,-1.5, h);
                //glVertex3f(3.1,0, 1.1/4*h);
                glVertex3f(3,-1.5,0); glVertex3f(3.1,-1.7,h); glVertex3f(3, -1.9, h/2);    glVertex3f(3,-2,h);

                 //glVertex3f(3,-2,h); //avant
          glEnd();*/

          /*glBegin(GL_POLYGON);//faces avantdiagonal
                glVertex3f(4,2,0);      glVertex3f(4,2,h);
                glVertex3f(5,1,h);     glVertex3f(5,1,0);
                glVertex3f(4,2,0);
             glEnd();
          glBegin(GL_POLYGON);
                glVertex3f(4,-2,0);      glVertex3f(4,-2,h);
                glVertex3f(5,-1,h);     glVertex3f(5,-1,0);
                glVertex3f(4,-2,0);
             glEnd();        */

        glPushMatrix();

            glEnable(GL_BLEND);
                                    //la couleur de l'objet va tre (1-alpha_de_l_objet) * couleur du fond et (le_reste * couleur originale)
            glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        glTranslatef(5,0,0);                   //voile
        glRotatef(Form1->deltav*RadToDeg,0,0,1);
        float a=-atan(fv/500);
        GLfloat jaune[] = {0.8f, 0.8f, 0.0f, 0.9f}; // 4me point donne la transparence


        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D,2);
           glBegin(GL_TRIANGLE_FAN);
                  glColor4fv(jaune);  // 4 au lieu de 3 pour la transparence
                  glTexCoord2f(0.0,0.0);
                  glVertex3f(0,0,2);

                  glTexCoord2f(1.0*3, 0.0);
                  glVertex3f(0,0,12);

                  glTexCoord2f(0.8*3,1/5*a/3);
                  glVertex3f(-1,a*1.5,10);

                  glTexCoord2f(0.6*3,2/5*a/3);
                  glVertex3f(-2,a*2,8);

                  glTexCoord2f(0.4*3,3/5*a/3);
                  glVertex3f(-3,a*2,6);

                  glTexCoord2f(0.2*3,4/5*a/3);
                  //glTexCoord2f(0.0,1.0);
                  glVertex3f(-4,a*1.5,4);

                  glTexCoord2f(0,1);
                  glVertex3f(-5,0,2);
           glEnd();
           glDisable(GL_BLEND);
           glDisable(GL_TEXTURE_2D);
        glTranslatef(0,0,2);
        glRotatef(-90,0,1,0);
        glEnable(GL_TEXTURE_2D);         //bome
        glBindTexture(GL_TEXTURE_2D,5);

        GLUquadricObj*q1=gluNewQuadric();
        gluQuadricOrientation(q1, GLU_OUTSIDE);
        //gluQuadricDrawStyle(q1,GLU_FILL);
        gluQuadricTexture(q1, GL_TRUE);
        gluCylinder(q1,0.1,0.1,5.5, 10,10);
        gluDeleteQuadric(q1);
        glDisable(GL_TEXTURE_2D);

         glPopMatrix();
         glPushMatrix();
         glTranslatef(-1,0,0);                   //gouvernail
        glRotatef(Form1->deltag*RadToDeg,0,0,1);
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D, 5);
        glBegin(GL_POLYGON);
                glColor3f(1,-EP_GOUV/2,0);
                glTexCoord2f(0.5,0); glVertex3f(0,-EP_GOUV/2,1);
                glTexCoord2f(0,0); glVertex3f(0,-EP_GOUV/2,0);
                glTexCoord2f(0,0.5); glVertex3f(-0.6,-EP_GOUV/2,0);
                glTexCoord2f(0.5,0.25); glVertex3f(-0.3,-EP_GOUV/2,1);
                glTexCoord2f(0.5,0); glVertex3f(0,-EP_GOUV/2,1);
        glEnd();
        glBegin(GL_POLYGON);
                glColor3f(1,EP_GOUV/2,0);
                glTexCoord2f(0.5,0); glVertex3f(0,EP_GOUV/2,1);
                glTexCoord2f(0,0); glVertex3f(0,EP_GOUV/2,0);
                glTexCoord2f(0,0.5); glVertex3f(-0.6,EP_GOUV/2,0);
                glTexCoord2f(0.5,0.25); glVertex3f(-0.3,EP_GOUV/2,1);
                glTexCoord2f(0.5,0); glVertex3f(0,EP_GOUV/2,1);
        glEnd();
        glBegin(GL_POLYGON);
                glColor3f(1,EP_GOUV/2,0);
                glTexCoord2f(1,0); glVertex3f(0,-EP_GOUV/2,1); glTexCoord2f(1,0.1); glVertex3f(0,EP_GOUV/2,1);
                glTexCoord2f(0.8,0); glVertex3f(0,-EP_GOUV/2,0); glTexCoord2f(0.8,0.1); glVertex3f(0,EP_GOUV/2,0);
                glTexCoord2f(0.6,0); glVertex3f(-0.6,-EP_GOUV/2,0); glTexCoord2f(0.6,0.1); glVertex3f(-0.6,EP_GOUV/2,0);
                glTexCoord2f(0.4,0); glVertex3f(-0.3,-EP_GOUV/2,1); glTexCoord2f(0.4,0.1); glVertex3f(-0.3,EP_GOUV/2,1);
                glTexCoord2f(0.2,0); glVertex3f(0,-EP_GOUV/2,1); glTexCoord2f(0.2,0.1);  glVertex3f(0,EP_GOUV/2,1);
        glEnd();
        glDisable(GL_TEXTURE_2D);
         float b=fg/300;

        glBegin(GL_LINES);                       //force gouvernail
                glColor3f(1,1,0);
                glVertex3f(-1,0,0.5);
                glVertex3f(-1,b,0.5);
        glEnd();

        glTranslatef(-0.6,0,h);
        glRotatef(90,0,1,0);
        glEnable(GL_TEXTURE_2D);         //barre
        glBindTexture(GL_TEXTURE_2D,7);

        q1=gluNewQuadric();
        gluQuadricOrientation(q1, GLU_OUTSIDE);
        //gluQuadricDrawStyle(q1,GLU_FILL);
        gluQuadricTexture(q1, GL_TRUE);
        gluCylinder(q1,0.05,0.05,3, 10,10);
        gluDeleteQuadric(q1);
        glDisable(GL_TEXTURE_2D);

        glPopMatrix();
        glTranslatef(5,0,0);
        glEnable(GL_TEXTURE_2D);         //mt
        glBindTexture(GL_TEXTURE_2D,5);

        q1=gluNewQuadric();
        gluQuadricOrientation(q1, GLU_OUTSIDE);
        //gluQuadricDrawStyle(q1,GLU_FILL);
        gluQuadricTexture(q1, GL_TRUE);
        gluCylinder(q1,0.08,0.08,14, 10,10);
        gluDeleteQuadric(q1);
        glDisable(GL_TEXTURE_2D);
        /*glLineWidth(4);
        glBegin(GL_LINES);              //mt
                glColor3f(0,0,0);
                glVertex3f(5,0,0);     glVertex3f(5,0,14);
        glEnd(); */
}
//---------------------------------------------------------------------------

